// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from fadecandy_msgs:msg/LEDStrip.idl
// generated code does not contain a copyright notice
#include "fadecandy_msgs/msg/detail/led_strip__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `colors`
#include "std_msgs/msg/detail/color_rgba__functions.h"

bool
fadecandy_msgs__msg__LEDStrip__init(fadecandy_msgs__msg__LEDStrip * msg)
{
  if (!msg) {
    return false;
  }
  // colors
  if (!std_msgs__msg__ColorRGBA__Sequence__init(&msg->colors, 0)) {
    fadecandy_msgs__msg__LEDStrip__fini(msg);
    return false;
  }
  return true;
}

void
fadecandy_msgs__msg__LEDStrip__fini(fadecandy_msgs__msg__LEDStrip * msg)
{
  if (!msg) {
    return;
  }
  // colors
  std_msgs__msg__ColorRGBA__Sequence__fini(&msg->colors);
}

bool
fadecandy_msgs__msg__LEDStrip__are_equal(const fadecandy_msgs__msg__LEDStrip * lhs, const fadecandy_msgs__msg__LEDStrip * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // colors
  if (!std_msgs__msg__ColorRGBA__Sequence__are_equal(
      &(lhs->colors), &(rhs->colors)))
  {
    return false;
  }
  return true;
}

bool
fadecandy_msgs__msg__LEDStrip__copy(
  const fadecandy_msgs__msg__LEDStrip * input,
  fadecandy_msgs__msg__LEDStrip * output)
{
  if (!input || !output) {
    return false;
  }
  // colors
  if (!std_msgs__msg__ColorRGBA__Sequence__copy(
      &(input->colors), &(output->colors)))
  {
    return false;
  }
  return true;
}

fadecandy_msgs__msg__LEDStrip *
fadecandy_msgs__msg__LEDStrip__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  fadecandy_msgs__msg__LEDStrip * msg = (fadecandy_msgs__msg__LEDStrip *)allocator.allocate(sizeof(fadecandy_msgs__msg__LEDStrip), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(fadecandy_msgs__msg__LEDStrip));
  bool success = fadecandy_msgs__msg__LEDStrip__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
fadecandy_msgs__msg__LEDStrip__destroy(fadecandy_msgs__msg__LEDStrip * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    fadecandy_msgs__msg__LEDStrip__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
fadecandy_msgs__msg__LEDStrip__Sequence__init(fadecandy_msgs__msg__LEDStrip__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  fadecandy_msgs__msg__LEDStrip * data = NULL;

  if (size) {
    data = (fadecandy_msgs__msg__LEDStrip *)allocator.zero_allocate(size, sizeof(fadecandy_msgs__msg__LEDStrip), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = fadecandy_msgs__msg__LEDStrip__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        fadecandy_msgs__msg__LEDStrip__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
fadecandy_msgs__msg__LEDStrip__Sequence__fini(fadecandy_msgs__msg__LEDStrip__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      fadecandy_msgs__msg__LEDStrip__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

fadecandy_msgs__msg__LEDStrip__Sequence *
fadecandy_msgs__msg__LEDStrip__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  fadecandy_msgs__msg__LEDStrip__Sequence * array = (fadecandy_msgs__msg__LEDStrip__Sequence *)allocator.allocate(sizeof(fadecandy_msgs__msg__LEDStrip__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = fadecandy_msgs__msg__LEDStrip__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
fadecandy_msgs__msg__LEDStrip__Sequence__destroy(fadecandy_msgs__msg__LEDStrip__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    fadecandy_msgs__msg__LEDStrip__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
fadecandy_msgs__msg__LEDStrip__Sequence__are_equal(const fadecandy_msgs__msg__LEDStrip__Sequence * lhs, const fadecandy_msgs__msg__LEDStrip__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!fadecandy_msgs__msg__LEDStrip__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
fadecandy_msgs__msg__LEDStrip__Sequence__copy(
  const fadecandy_msgs__msg__LEDStrip__Sequence * input,
  fadecandy_msgs__msg__LEDStrip__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(fadecandy_msgs__msg__LEDStrip);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    fadecandy_msgs__msg__LEDStrip * data =
      (fadecandy_msgs__msg__LEDStrip *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!fadecandy_msgs__msg__LEDStrip__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          fadecandy_msgs__msg__LEDStrip__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!fadecandy_msgs__msg__LEDStrip__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
