// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from fadecandy_msgs:msg/LEDStrip.idl
// generated code does not contain a copyright notice

#ifndef FADECANDY_MSGS__MSG__DETAIL__LED_STRIP__STRUCT_H_
#define FADECANDY_MSGS__MSG__DETAIL__LED_STRIP__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'colors'
#include "std_msgs/msg/detail/color_rgba__struct.h"

/// Struct defined in msg/LEDStrip in the package fadecandy_msgs.
/**
  * Color of each LED in the strip. Fadecandy firmware only allows up to 64 LEDs per strip.
  * Only the R, G, and B values get used; the alpha value is ignored.
 */
typedef struct fadecandy_msgs__msg__LEDStrip
{
  std_msgs__msg__ColorRGBA__Sequence colors;
} fadecandy_msgs__msg__LEDStrip;

// Struct for a sequence of fadecandy_msgs__msg__LEDStrip.
typedef struct fadecandy_msgs__msg__LEDStrip__Sequence
{
  fadecandy_msgs__msg__LEDStrip * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} fadecandy_msgs__msg__LEDStrip__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // FADECANDY_MSGS__MSG__DETAIL__LED_STRIP__STRUCT_H_
